<?php
/**
* @author Mikko Rönkkö
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_PLUGINS->registerFunction( 'onBeforeUserProfileDisplay', 'checkForConfigUpdates','listTab' );

class listTab extends cbTabs {

	function listTab() {
		$this->cbTabs(0,1,new cbCalendars(1));
	}

	function getDisplayTab($tab, $user, $ui) {
		
		$ret='';

		//Prevent CB from drawing fields
		$tab->fields=array();
		
		if($tab->description!=null){
			$ret.="<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>";
			$tab->description=null;
		}
		$data=$this->_getData($tab,$user);
		
		$content="";	
		foreach($data as $record){
			$content.=$this->_getViewTabContents($tab->tabid,$record);
		}
		
		//Modify the view to be a one single table
		

		$content=$this->_transformToList($content,$tab);
			
	
		
		$ret.=$content;

			
		return $ret;	
	}
	function getDisplayRegistration($tab, $user, $ui) {
	
		global $database;
		$database->setQuery("SELECT count(tabid) FROM #__comprofiler_tabs WHERE tabid=".$tab->tabid." and params ='no-registration'");
		
		if($database->loadResult()==1)
			return "";
		else		
			return "<tr><td colspan=2><hr>".$this->getEditTab($tab, $user, $ui)."</td></tr>";
	}
	
	function getEditTab($tab, $user, $ui) {

		global $database;
		
		$sql="select title, type from #__comprofiler_fields  where tabid=".$tab->tabid." and published=1 order by ordering limit 1";
		$database->setQuery($sql);
		$fi=$database->loadObjectList();
		$fi=$fi[0];
		$firstField=strtolower(getLangDefinition($fi->title));
		$this->_getLanguageFile();
		$ret='';
		$isFirstSelect=($fi->type=='select');
		
		//Prevent CB from drawing fields
		$tab->fields=array();

		if($tab->description!=null){
			$ret.="<div class=\"tab_Description\">".unHtmlspecialchars(getLangDefinition($tab->description))."</div>";
			$tab->description=null;
		}
		$ret.=$this->_getHeader($tab,$user,$firstField,$isFirstSelect,$ui);
		
		$data=$this->_getData($tab,$user);
		$content="";
		if($data!=null){
			foreach($data as $record){
				$content.= "<div><input class=\"button\" name=\"btndelete\" value=\""._UE_DELETE_ENTRY."\" onclick=\"if(confirm ('"._UE_DELETE_ENTRY." ".$firstField.": '+getValue(this.parentNode,".$isFirstSelect.")))this.parentNode.innerHTML='';\" type=\"button\">";
				$content.= str_replace('name="cb_','name="'.$record->extid.'cb_',$this->_getEditTabContents($tab,$record));
				$content.="</div>";

			}
		}
		else{
			$content.= "<div>";
			$content.= str_replace('name="cb_','name="0cb_',$this->_getEditTabContents($tab,new stdClass()));
			$content.="</div>";
		}
		$ret.=$content;
		
//@TODO make edit also use tables $ret.=$this->_transformToList($content,$tab);
		$ret.=$this->_getFooter($tab,$user,$firstField);

		return $ret;	
	}

	function _getData($tab,$user){
		global $database;
		
		$database->setQuery("SELECT * FROM #__comprofiler_listtab_".$tab->tabid." WHERE userid='".$user->id."' "); //and tabid='".$tab->tabid."'
		return $database->loadObjectList();
	}
	function _getLanguageFile() {
		global $mainframe,$mosConfig_lang;
		$UElanguagePath=$mainframe->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/user/plug_listtab';
		if (file_exists($UElanguagePath.'/language/'.$mosConfig_lang.'.php')) {
		  include_once($UElanguagePath.'/language/'.$mosConfig_lang.'.php');
		} else include_once($UElanguagePath.'/language/english.php');	
	}


	function _getHeader($tab,$user,$firstField,$isFirstSelect,$ui){
		global $database;
		$p="";
		if($ui==2)
			$p="../";
		$ret  ="<script src=\"".$p."components/com_comprofiler/plugin/user/plug_listtab/funcs.js\" type=\"text/javascript\"></script>";
		$ret .="<script type=\"text/javascript\">";
		$ret .="\nvar count".$tab->tabid."=0;";
		$ret .="\nfunction new".$tab->tabid."(obj){\n";
		$ret .="count".$tab->tabid."++;";
		$ret .="\nvar t=document.getElementById('tbl_".$tab->tabid."');";
		$ret .="\nvar x=t.insertRow(t.rows.length-1);"
			."\nvar y=x.insertCell(0);"
			."\ny.innerHTML=replaceAll('";

//Build the HTML
		$results = "<div><input class=\"button\" name=\"btndelete\" value=\""._UE_DELETE_ENTRY."\" onclick=\"if(confirm ('"._UE_DELETE_ENTRY.
			" ".$firstField.": '+getValue(this.parentNode,".$isFirstSelect.")))this.parentNode.innerHTML='';\" type=\"button\">";

//Here goes an empty edit tab that has all ', \n and \ escaped to make it javascript string
		$results .=str_replace('id="cb_','id="newNEWIDHEREcb_',str_replace('name="cb_','name="newNEWIDHEREcb_',$this->_getEditTabContents($tab,new stdClass())));

		$results .="</div>";

		$retArr =explode("<script type=\"text/javascript\">",$results);
		$end ="";

		$results=$retArr[0];
		
		for($i=1,$n=count($retArr);$i<$n;++$i){
			$tempArr=explode("</script>",$retArr[$i]);
			$end.="\nvar temp=('".str_replace("\n","",str_replace('inputField : "','inputField : "new\'+count'.$tab->tabid.'+\'',$tempArr[0]))."');";
//			$end.="\nalert(temp);";
			$end.="\neval(temp);";
			$results.=$tempArr[1];
//			die("\n\n".$end);
		}
		$ret .=str_replace("\n","",str_replace("'","\\'",str_replace("\\","\\\\",$results)));

		$ret .="','NEWIDHERE',count".$tab->tabid.");";
		if($this->params->get('enableConditions','0')==1){
			$ret.="\ninitElements(document.getElementById('tbl_".$tab->tabid."'));";
			$ret.="\napplyConditions(document.getElementById('tbl_".$tab->tabid."'));";
		}
		if($this->params->get('enableExtendedSelect','0')==1){
	
			global $mainframe,$mosConfig_lang;
			$UElanguagePath=$mainframe->getCfg( 'absolute_path' ).'/components/com_comprofiler/plugin/user/plug_extendedselect';
			if (file_exists($UElanguagePath.'/language/'.$mosConfig_lang.'.php')) {
			  include_once($UElanguagePath.'/language/'.$mosConfig_lang.'.php');
			} else include_once($UElanguagePath.'/language/english.php');				
		
			$sql="select params from #__comprofiler_plugin where element='extendedselect'";
			$database->setQuery($sql);
			$extselParams=$database->loadResult();
						
			$tempArr=array_filter(explode("\n",$extselParams),"filterExtSel");
			
			$tempArr=explode("=",$tempArr[0]);			
			$selects=explode("|*|",$tempArr[1]);
			
			
			foreach($selects as $select){
				$ret.=("\nenableExtendedSelect(count".$tab->tabid."+'".$select."[]','".getLangDefinition('_UE_OTHER_ENTRY')."','".getLangDefinition('_UE_INSERT_ENTRY')."');");
			}	
	
		}
		
		$ret .= $end; 
		$ret .="}</script>";

		//$ret .='<table id="tbl_'.$tab->tabid.'"><tr><td><input type="button" class="button" name=btnnew value="New" onclick="new'.$tab->tabid.'(this);" /></td></tr></table>';

		//Then we create some hidden fields as a workaround to pass required fields test of CB core on the server side
		//This is pretty ugly, so if you have a better idea, please notify the author
		
		$sql="select name, type, MIN(fieldtitle) as fieldtitle from #__comprofiler_fields f left join #__comprofiler_field_value_lists l on f.fieldid=l.fieldid".
		" left join #__comprofiler_field_values v on l.fieldvaluelistid = v.fieldid".
		" where tabid=".$tab->tabid." and required=1 and published=1 group by name";
		$database->setQuery($sql);

		$reqFields=$database->loadObjectList();

		foreach($reqFields as $reqField){
			if($reqField->type=='radio'||$reqField->type=='multiselect'||$reqField->type=='multicheckbox'||$reqField->type=='select')
				$ret.='<input type="hidden" name="'.$reqField->name.'[]" value="'.$reqField->fieldtitle.'">';		
			else{			
				$ret.='<input type="hidden" name="'.$reqField->name.'" value="-">';
			}		
		}		
		return $ret;
	}
	function _getFooter($tab,$user,$firstField){

		
		$title=$firstField;


		$ret ='<table id="tbl_'.$tab->tabid.'"><tr><td><input type="button" class="button" name=btnnew value="'._UE_NEW_ENTRY.' '.$title.'" onclick="new'.$tab->tabid.'(this);" /></td></tr></table>';

		return $ret;
	}


	function saveRegistrationTab($tab, $user, $ui, $postdata) {
		$this->saveEditTab($tab, $user, $ui, $postdata);
	}

	function saveEditTab($tab, $user, $ui, $postdata) {
		
		global $database, $mosConfig_debug;
	
		$sql= "SELECT extid FROM #__comprofiler_listtab_".$tab->tabid." WHERE userid= ". $user->id ;

	
		$database->setQuery($sql);
	
		$extIds = $database->loadResultArray();
	

		$database->setQuery( "SELECT * FROM #__comprofiler_fields WHERE published=1 and tabid = ".$tab->tabid." and readonly=0" );

		$rowFields = $database->loadObjectList();
	
		$cbFields=new cbFields();

		foreach($extIds as $extId){
			$dataFound=false;
			$rowExtras = new stdClass();
			for($i=0, $n=count( $rowFields ); $i < $n; $i++) {
				if($mosConfig_debug) echo("<br>Trying to get POST variable ".$extId.$rowFields[$i]->name);
				$field=cbGetEscaped($rowFields[$i]->name);
				$value=null;
				if(isset($_POST[$extId.$rowFields[$i]->name])){
					$value=$cbFields->prepareFieldDataSave($rowFields[$i]->fieldid,$rowFields[$i]->type,$rowFields[$i]->name,$_POST[$extId.$rowFields[$i]->name]);
					if($value!=''){
						$dataFound=true;
					}
					$rowExtras->$field=$value;
				}
			}
			$rowExtras->extid=$extId;
			$rowExtras->userid=$user->id;
//			$rowExtras->tabid=$tab->tabid;
			
//If data is found, do UPDATE else do DELETE

			if($dataFound){
				$database->updateObject( '#__comprofiler_listtab_'.$tab->tabid, $rowExtras, 'extid'); 
//				die($database->stderr(true));
				if($database->getErrorNum()==1054){
					$this->_modifyColumns($tab->tabid); //Check if new fields have been added but are not in the table yet and updata the table
					
					$database->updateObject( '#__comprofiler_listtab_'.$tab->tabid, $rowExtras, 'extid');
				}
				
			}
			else{
				$sql = "DELETE FROM #__comprofiler_listtab_".$tab->tabid." WHERE userid=".$user->id." AND extid=".$extId;
				$database->setQuery($sql);
				if (!$database->query()) {
					echo "<script type=\"text/javascript\"> alert('store:".$database->stderr(true)."'); window.history.go(-1);</script>\n";
				}
//				die($database->stderr(true));

			}
		}

//Updates and deletes processed this far. Let's do inserts next. 		

		if($mosConfig_debug) print_r($_POST);

		for ($newid=0; $newid<=20; $newid++){
			$dataFound=false;

			$rowExtras = new stdClass();
			for($i=0, $n=count( $rowFields ); $i < $n; $i++) {
				$field=cbGetEscaped($rowFields[$i]->name);
				$value=null;

				if(isset($_POST["new".$newid.$rowFields[$i]->name])){
					if($mosConfig_debug) echo("<br>LISTTAB found post data "."new".$newid.$rowFields[$i]->name."=".$_POST["new".$newid.$rowFields[$i]->name]);
					$value=$cbFields->prepareFieldDataSave($rowFields[$i]->fieldid,$rowFields[$i]->type,$rowFields[$i]->name,$_POST["new".$newid.$rowFields[$i]->name]);
					if($value!=''){
						$dataFound=true;
						if($mosConfig_debug) echo(" - VALID<br>");
					
					}
					else
						if($mosConfig_debug) echo(" - INVALID<br>");

				}

				$rowExtras->$field=$value;
			
			}
			
			$rowExtras->userid=$user->id;
//			$rowExtras->tabid=$tab->tabid;
			
//If data is found, do INSERT

			if($dataFound){
				if($mosConfig_debug) echo("<br>LISTTAB is inserting data<br>");
			
				$database->insertObject( '#__comprofiler_listtab_'.$tab->tabid, $rowExtras);
				if($database->getErrorNum()==1054){
					
					$this->_modifyColumns($tab->tabid); //Check if new fields have been added but are not in the table yet and update the table
					
					$database->insertObject( '#__comprofiler_listtab_'.$tab->tabid, $rowExtras); 
				}
				
			}
		}
	}

	function loadTabList($name,$value,$control_name) {
	
	global $database;

	$database->setQuery("select tabid, title from #__comprofiler_tabs where pluginclass is null or pluginclass = 'listtab'");
	$tabs = $database->loadObjectList();
	$tabList = array();
	
	$tabList[] = mosHTML::makeOption(-1,'none');
	foreach ($tabs as $tab) {
			$tabList[] = mosHTML::makeOption( $tab->tabid, $tab->title);
	}
	$valAsObj = (isset($value)&&$value!='') ?
	array_map(create_function('$v', '$o=new stdClass(); $o->value=$v; return $o;'), explode("|*|", $value ))
	:$this->_getSelectedTabs();

	return moscomprofilerHTML::selectList( $tabList, $control_name .'['. $name .'][]', 'size="4" multiple="multiple"', 'value', 'text', $valAsObj, true );	
		
	}
	function _getSelectedTabs(){
	
	global $database;
	
	$database->setQuery("select tabid, title from #__comprofiler_tabs where pluginclass = 'listtab'");
	$tabs = $database->loadObjectList();
	$tabList = array();
	
	foreach ($tabs as $tab) {
			$tabList[] = mosHTML::makeOption( $tab->tabid, null);
	}

	return $tabList;
	}

	function checkForConfigUpdates($a,$b,$c,$d){
		
		global $database;
		$database->setQuery("select count(id) from #__comprofiler_plugin where element='listtab' and params like '%listEnabledTabs%'");
		$debug=$database->loadResult();

		if($database->loadResult()==1){
		//lets update the tabs

			
			$tabsToUpdate =  explode("|*|", $this->params->get('listEnabledTabs',''));
			$pluginId=$this->id;
			$modifyComprofiler = $this->params->get('modifyComprofiler','0');
			$enableConditions = $this->params->get('enableConditions','0');
			$enableExtendedSelect = $this->params->get('enableExtendedSelect','0');


			$showAsLists = $this->params->get('showAsLists','0');

			$sql="UPDATE #__comprofiler_plugin SET params ='enableConditions=".$enableConditions.
			"\nenableExtendedSelect=".$enableExtendedSelect.			
			"\nmodifyComprofiler=".$modifyComprofiler.
			"\nshowAsLists=".$showAsLists."'  where element='listtab'";
			
			//debug echo ($sql."\n");			
		
			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}

			$sql="UPDATE #__comprofiler_tabs SET pluginclass = null,".
				" pluginid = null where pluginclass ='listtab'";
				//debug echo ($sql."\n");			
		
			$database->SetQuery($sql);
			
			if (!$database->query()) {
				echo "<script type=\"text/javascript\"> alert('store:".
					$database->stderr(true)."'); window.history.go(-1);</script>\n";
			}
			
			foreach($tabsToUpdate as $tab){

				$sql="CREATE TABLE IF NOT EXISTS `#__comprofiler_listtab_".$tab.
					"` (`extid` INT NOT NULL AUTO_INCREMENT ,`userid` INT NOT NULL ,".
					"PRIMARY KEY ( `id` ));";

				//debug echo ($sql."\n");			

				$database->SetQuery($sql);

				if (!$database->query()) {
					echo "<script type=\"text/javascript\"> alert('store:".
						$database->stderr(true)."'); window.history.go(-1);</script>\n";
				}						
				$sql="UPDATE #__comprofiler_tabs SET pluginclass ='listtab',".
					" pluginid=".$pluginId." where tabid=".$tab;
				//debug echo ($sql."\n");			
				
				$database->SetQuery($sql);
				if (!$database->query()) {
					echo "<script type=\"text/javascript\"> alert('store:".
						$database->stderr(true)."'); window.history.go(-1);</script>\n";
				}						
			
				$this->_modifyColumns($tab);
		
			}

			//next we need to be sure that columns are moved back.

			$sql="SELECT f.name, f.type, f.fieldid, f.tabid from #__comprofiler_fields f,".
				" #__comprofiler_tabs t where f.tabid=t.tabid and".
				" (t.pluginclass IS NULL OR t.pluginclass NOT LIKE 'listtab')"; 
			$database->setQuery($sql);
			$fieldList=$database->loadObjectList();


			foreach($fieldList as $field){
				$this->checkAndModifyField($field,'#__comprofiler','#__comprofiler_listtab_'.$field->tabid,$modifyComprofiler);
			}
//			die("debug");
		}
	}
	function _modifyColumns($tab){

		global $database;

		$sql="SELECT name, type, fieldid from #__comprofiler_fields where tabid=".$tab;

		//debug echo ($sql."\n");			

		//these must exist in the external table
		$database->setQuery($sql);
		$fieldList=$database->loadObjectList();

		$modifyComprofiler = $this->params->get('modifyComprofiler','0');

		foreach($fieldList as $field){
			$this->checkAndModifyField($field,'#__comprofiler_listtab_'.$tab,'#__comprofiler',$modifyComprofiler);
		}
						
	}	
	
	function checkAndModifyField($field,$insertTo,$removeFrom,$deleteOriginal){
	
		global $database;
		$sql="SHOW COLUMNS FROM ".$insertTo." LIKE '".$field->name."'";
		//debug echo ($sql."\n delete original=".$deleteOriginal);					
		$database->setQuery($sql);		
		$obj=$database->LoadResult();
		if($obj==false or $obj == null or $obj==''){

			SWITCH($field->type) {
					CASE 'date':
						$cType='DATE';
					break;
					CASE 'editorta':
					CASE 'textarea':
					CASE 'multiselect':
					CASE 'multicheckbox':
						$cType='MEDIUMTEXT';
					break;	
					CASE 'checkbox':
						$cType='TINYINT';
					break;			
					default:
						$cType='VARCHAR(255)';
					break;

				
			}
			$name=$field->name;
			$sql="ALTER TABLE `$insertTo` ADD `$name` $cType";
			//debug echo ($sql."\n");			
			$database->setQuery($sql);
			$database->query();
			//Copy data from external table to comprofiler
			if($insertTo=='#__comprofiler'){
				//@todo: implement data copying
			}
			else{
				//@todo: implement data copying
			}
		
			if($deleteOriginal==1){
				$sql="ALTER TABLE `$removeFrom` DROP `$name`";
				//debug echo ($sql."\n");			
				$database->setQuery($sql);
				$database->query();
				
			}	
		
			$sql="UPDATE #__comprofiler_fields SET `table`='".$insertTo."' WHERE fieldid=".$field->fieldid;
			//debug echo ($sql."\n");			
			$database->setQuery($sql);
			$database->query();
			
		}
	}
	function _transformToList($content,$tab){
		if(in_array($tab->tabid,explode("|*|",$this->params->get('showAsLists','')))){

			$content=str_replace('</tr>','',$content);
			$content=ereg_replace('<tr class="sectiontableentry.">','',$content);
			$content=ereg_replace('<tr>','',$content);
			$content=str_replace('<table class="cbFields" cellpadding="0" cellspacing="0" style="width:95%">',"<tr>",$content);
			$content=str_replace('<table cellpadding="5" cellspacing="0" border="0" width="100%">',"<tr>",$content);

			$content=str_replace('</table>',"</tr>",$content);	

			$header=substr($content,0,strpos($content,"</tr>"));
			
			$content=ereg_replace('<td class="titleCell">[^<]*</td>','',$content);
//			$header=ereg_replace('<td^[ class="titleCell"][^<]*</td>','',$header);
			$header=ereg_replace('<td colspan="1"[^<]*</td>','',$header);
//			$header="";
			$content="<table>".$header.$content."</table>";
		}
			
		return $content;
	}
}	// end class listTab.

	
	function filterExtSel($var){
		//print "\ninside callback\n";
		$ret=(strpos($var,"fields=")==0);
		//print $var." Qualifies:".$ret."\n";		
		return $ret;
	}
?>
